Request

Response

    Retrieve Issues (new)

    This tutorial demonstrates how to retrieve a project’s issue IDs. The steps include retrieving the container ID for the project and retrieving a list of the issue IDs. Each project is assigned a container that stores all the issues for the project. You need to use the Data Management API to retrieve the container ID for the project.

    There are two types of issues:

    • Issues that are associated with a project but not associated with a specific document.
    • Issues associated with a specific document (pushpin issues).

    Note that we support managing issues that are associated with a project. However, regarding issues associated with a specific document, we only currently support tracking these issues, but not creating, updating or locating the issues within the document.

    Before You Begin

    Step 1: Find the Hub ID

    You first need to call GET hubs to find the hub ID for your BIM 360 account.

    Note that the BIM 360 account ID corresponds to a Data Management hub ID. To convert an account ID into a hub ID you need to add a “b." prefix. For example, an account ID of c8b0c73d-3ae9 translates to a hub ID of b.c8b0c73d-3ae9.

    Request

    curl -X GET -H "Authorization: Bearer nFRJxzCD8OOUr7hzBwbr06D76zAT" "https://developer.api.autodesk.com/project/v1/hubs"
    

    Response

    {
      "jsonapi": {
        "version": "1.0"
      },
      "links": {
        "self": {
          "href": "https://developer.api.autodesk.com/project/v1/hubs"
        }
      },
      "data": [
        {
          "type": "hubs",
          "id": "b.cGVyc29uYWw6cGUyOWNjZjMy",
          "attributes": {
            "name": "My First Account",
            "extension": {
              "type": "hubs:autodesk.bim360:Account",
              "version": "1.0",
              "schema": {
                "href": "https://developer.api.autodesk.com/schema/v1/versions/hubs:autodesk.bim360:Account-1.0"
              },
              "data": {}
            }
          }
        }
      ]
    }
    
    Show More

    In this example, assume that the project you want the container for is in My First Account hub.

    Step 2: Find the Issues Container ID for the Project

    Use the BIM 360 hub ID that you retrieved in the previous step (b.cGVyc29uYWw6cGUyOWNjZjMy) to call GET hubs/:hub_id/projects, and retrieve a list of all the projects in the hub the user has access to. In this example, we have added a filter to only return details of a specific project (My First Project).

    Request

    curl -X GET -H "Authorization: Bearer nFRJxzCD8OOUr7hzBwbr06D76zAT" "https://developer.api.autodesk.com/project/v1/hubs/b.cGVyc29uYWw6cGUyOWNjZjMy/projects?filter%5Battributes.name%5D=My%20First%20Project"
    

    Response

    {
      "jsonapi": {
        "version": "1.0"
      },
      "links": {
        "self": {
          "href": "https://developer.api.autodesk.com/project/v1/hubs/b.cGVyc29uYWw6cGUyOWNjZjMy/projects"
        }
      },
      "data": [
        {
          "type": "projects",
          "id": "b.cGVyc29uYWw6cGUyOWNjZjMyI0QyMDE2MDUyNDEyOTI5NzY",
          "attributes": {
            "name": "My First Project",
            "extension": {
              "type": "projects:autodesk.bim360:Project",
              "version": "1.0",
              "schema": {
                "href": "https://developer.api.autodesk.com/schema/v1/versions/projects%3Aautodesk.core%3AProject-1.0"
              },
              "data": {}
            }
          },
          "links": {
            "self": {
              "href": "https://developer.api.autodesk.com/project/v1/hubs/b.cGVyc29uYWw6cGUyOWNjZjMy/projects/b.57be304852e74856a61bf25acebc200f"
            }
          },
          "relationships": {
            "hub": {
              "data": {
                "type": "hubs",
                "id": "b.cGVyc29uYWw6cGUyOWNjZjMy"
              },
              "links": {
                "related": {
                  "href": "https://developer.api.autodesk.com/project/v1/hubs/b.cGVyc29uYWw6cGUyOWNjZjMy"
                }
              }
            },
            "rootFolder": {
              "data": {
                "type": "folders",
                "id": "urn:adsk.wipprod:fs.folder:co.uvDiLQ5DRYidDQ_EFW1OOg"
              },
              "meta": {
                "link": {
                  "href": "https://developer.api.autodesk.com/data/v1/projects/b.57be304852e74856a61bf25acebc200f/folders/urn%3Aadsk.wipprod%3Afs.folder%3Aco.uvDiLQ5DRYidDQ_EFW1OOg"
                }
              }
            },
            "topFolders": {
              "links": {
                "related": {
                  "href": "https://developer.api.autodesk.com/project/v1/hubs/b.cGVyc29uYWw6cGUyOWNjZjMy/projects/b.57be304852e74856a61bf25acebc200f/topFolders"
                }
              }
            },
            "issues": {
              "data": {
                "type": "issueContainerId",
                "id": "be00f32e-c03c-4c7b-9ec4-d2614bf1980c"
              }
            }
          }
        }
      ]
    }
    
    Show More

    The response payload includes the container ID (data.relationships.issues.data.id).

    Step 3: Find the Issue IDs

    Use the container ID (be00f32e-c03c-4c7b-9ec4-d2614bf1980cfor) to retrieve the project’s issues, by calling GET issues

    request

    curl "https://developer.api.autodesk.com/issues/v2/containers/6c8e8341-a4da-4959-a90d-e3b16c60ffd4/issues" -X GET \
      -H "Authorization: Bearer nFRJxzCD8OOUr7hzBwbr06D76zAT"
    

    response

    {
      "pagination": {
          "limit": 100,
          "offset": 0,
          "totalResults": 2
      },
      "results": [
          {
              "id": "788bc959-233f-4307-b828-26794682ec4d",
              "containerId": "6c8e8341-a4da-4959-a90d-e3b16c60ffd4",
              "displayId": 1,
              "rootCauseId": null,
              "title": "test 1",
              "description": null,
              "issueTypeId": "a2b12543-e488-4578-bd4d-41212383ff5e",
              "issueSubtypeId": "a0a1b5a4-2c72-4bca-8de2-f2d0e2aa0e86",
              "status": "open",
              "assignedTo": null,
              "assignedToType": null,
              "dueDate": null,
              "locationId": null,
              "locationDetails": null,
              "snapshotUrn": null,
              "linkedDocuments": [],
              "links": [],
              "ownerId": "U6H9J8Z78B8N",
              "officialResponse": {
                  "response": null,
                  "respondedAt": null,
                  "respondedBy": null
              },
              "permittedAttributes": [
                  "title",
                  "description",
                  "issueTypeId",
                  "issueSubtypeId",
                  "status",
                  "assignedTo",
                  "assignedToType",
                  "dueDate",
                  "locationId",
                  "locationDetails",
                  "linkedDocuments",
                  "links",
                  "ownerId",
                  "rootCauseId",
                  "officialResponse",
                  "customAttributes",
                  "clientUpdatedAt",
                  "snapshotUrn"
              ],
              "permittedActions": [
                  "add_comment",
                  "add_attachment",
                  "assign_all",
                  "clear_assignee"
              ],
              "commentCount": 0,
              "attachmentCount": 0,
              "openedBy": "U6H9J8Z78B8N",
              "openedAt": "2021-06-22T06:59:57.556Z",
              "closedBy": null,
              "closedAt": null,
              "createdBy": "U6H9J8Z78B8N",
              "createdAt": "2021-06-22T06:59:57.568Z",
              "updatedBy": "U6H9J8Z78B8N",
              "updatedAt": "2022-09-12T08:06:42.539Z",
              "issueTemplateId": null,
              "customAttributes": [],
              "permittedStatuses": [
                  "open",
                  "answered",
                  "closed",
                  "void"
              ]
          },
          {
              "id": "59c74845-ab31-44d1-8598-04b8a5a560b0",
              "containerId": "b22aafc0-f586-416d-bdd9-17667dc2e117",
              "displayId": 31,
              "rootCauseId": null,
              "title": "New Item",
              "description": null,
              "issueTypeId": "3456d343-614d-4ea6-85c8-14bd333ae6b6",
              "issueSubtypeId": "478be241-e9c8-4447-9577-05d1a3faaa0b",
              "status": "open",
              "assignedTo": null,
              "assignedToType": null,
              "dueDate": null,
              "locationId": null,
              "locationDetails": null,
              "snapshotUrn": "urn:adsk.objects:os.object:ng-issues-prod-b22aafc0-f586-416d-bdd9-17667dc2e117/e74861ce-f490-4dc1-a17f-5e70e2d810a3",
              "linkedDocuments": [
                  {
                      "type": "TwoDVectorPushpin",
                      "urn": "urn:adsk.wipprod:dm.lineage:vnjsJaDmQh6OOBnYgzwUXQ",
                      "createdBy": "...",
                      "createdAt": "2022-11-28T12:48:37.188Z",
                      "createdAtVersion": 1,
                      "closedBy": null,
                      "closedAt": null,
                      "closedAtVersion": null,
                      "details": {
                          "viewable": {
                              "id": "05babd63-a4ad-5c53-b02b-9a8574bcefb7",
                              "guid": "05babd63-a4ad-5c53-b02b-9a8574bcefb7",
                              "name": "03 Floor Plan.ifc",
                              "is3D": true,
                              "viewableId": "03 Floor Plan.ifc"
                          },
                          "position": {
                              "x": -106.77637888241387,
                              "y": -60.76041506179583,
                              "z": 6.664661474679461
                          },
                          "objectId": 309,
                          "externalId": "2G_tjpeeOI4000000009_c",
                          "viewerState": {
                              "seedURN": "dXJuOmFkc2sud2lwcHJvZDpmcy",
                              "viewport": {
                                  "up": [
                                      0,
                                      0,
                                      1
                                  ],
                                  "eye": [
                                      "103.94791412353516",
                                      "-277.0862121582031",
                                      "1.7852157354354858"
                                  ],
                                  "name": "",
                                  "target": [
                                      "103.94791412353516",
                                      "68.5",
                                      "1.7852157354354858"
                                  ],
                                  "pivotPoint": [
                                      "103.94791412353516",
                                      "68.5",
                                      "1.7852157354354858"
                                  ],
                                  "projection": "perspective",
                                  "aspectRatio": 1.7908653846153846,
                                  "fieldOfView": 44.99999100695533,
                                  "worldUpVector": [
                                      0,
                                      0,
                                      1
                                  ],
                                  "isOrthographic": false,
                                  "distanceToOrbit": 345.5862121582031
                              },
                              "cutplanes": [],
                              "objectSet": [
                                  {
                                      "id": [],
                                      "hidden": [],
                                      "idType": "lmv",
                                      "isolated": [],
                                      "explodeScale": 0
                                  }
                              ],
                              "globalOffset": {
                                  "x": 103.9479166815678,
                                  "y": 68.49999999999999,
                                  "z": 1.7852156956990575
                              },
                              "renderOptions": {
                                  "toneMap": {
                                      "method": 1,
                                      "exposure": -7,
                                      "lightMultiplier": -1e-20
                                  },
                                  "appearance": {
                                      "ghostHidden": true,
                                      "antiAliasing": true,
                                      "displayLines": true,
                                      "ambientShadow": false,
                                      "displayPoints": true,
                                      "swapBlackAndWhite": false,
                                      "progressiveDisplay": true
                                  },
                                  "environment": "Boardwalk",
                                  "ambientOcclusion": {
                                      "radius": 13.123359580052492,
                                      "enabled": false,
                                      "intensity": 1
                                  }
                              },
                              "attributesVersion": 2
                          }
                      }
                  }
              ],
              "links": [
                  {
                      "type": "checklist",
                      "data": {
                          "urn1": "urn:adsk.checklists.cs.instance.item:b22aafc0-f586-416d-bdd9-17667dc2e117/87252924",
                          "urn2": "urn:adsk.checklists.cs.instance.section:b22aafc0-f586-416d-bdd9-17667dc2e117/14060247",
                          "urn3": "urn:adsk.checklists.cs.instance:b22aafc0-f586-416d-bdd9-17667dc2e117/2695283"
                      }
                  }
              ],
              "ownerId": "...",
              "officialResponse": {
                  "response": null,
                  "respondedAt": null,
                  "respondedBy": null
              },
              "permittedAttributes": [
                  "title",
                  "description",
                  "issueTypeId",
                  "issueSubtypeId",
                  "status",
                  "assignedTo",
                  "assignedToType",
                  "dueDate",
                  "locationId",
                  "locationDetails",
                  "linkedDocuments",
                  "links",
                  "ownerId",
                  "rootCauseId",
                  "officialResponse",
                  "customAttributes",
                  "clientUpdatedAt",
                  "snapshotUrn"
              ],
              "permittedActions": [
                  "add_comment",
                  "add_attachment",
                  "assign_all",
                  "clear_assignee"
              ],
              "commentCount": 0,
              "attachmentCount": 0,
              "openedBy": "...",
              "openedAt": "2022-11-28T12:31:27.134Z",
              "closedBy": null,
              "closedAt": null,
              "createdBy": "...",
              "createdAt": "2022-11-28T12:31:27.339Z",
              "clientCreatedAt": "2022-11-28T12:31:27.134Z",
              "updatedBy": "...",
              "updatedAt": "2022-11-28T12:48:44.335Z",
              "clientUpdatedAt": "2022-11-28T12:48:37.187Z",
              "issueTemplateId": null,
              "customAttributes": [],
              "permittedStatuses": [
                  "open",
                  "work_completed",
                  "ready_to_inspect",
                  "in_dispute",
                  "not_approved",
                  "closed",
                  "void"
              ]
          }
      ]
    }
    
    Show More

    The response payload includes the issues IDs (results.id).